#! /usr/bin/env python3

from fabric import Connection
import sys
import parmap


def connect_server(ip,cmd):
    result=Connection(host="user@192.168.0."+str(ip), connect_kwargs={"password": "PASSWORD"}).run(cmd, hide=True)
    msg = "{0.connection.host} {0.stdout}".format(result).rstrip()

    return msg


def main(ip,cmd):
    try:
        msg=connect_server(ip,cmd)
    except:
        msg=None
        #msg='ERROR: 192.168.0.'+str(ip)
    return msg

    
if __name__=='__main__':
    cmd=' '.join(sys.argv[1:])
    server=range(11,31)

    if cmd=='run':
        cmd='ps -e|grep python3.6|wc -l'
    elif cmd=='pk':
        cmd='pkill python3.6'
    elif cmd=='cmd':
        cmd='ps -C python3.6 -o %cpu,%mem,cmd --sort=-%cpu'
    elif cmd=='hdd1':
        cmd='df|grep hdd1'
        
    msgs=parmap.map(main,server,cmd,pm_pbar=False,pm_processes=len(server))

    msgs=filter(None,msgs)
    
    msg='\n'.join(msgs)
    print(msg)
